// $Id: config_reader.h,v 1.6 2003/01/06 17:51:30 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __config_reader_h__
#define __config_reader_h__

#include <iostream>
#include <fstream>
#include <string>
#include <list>

#include "config_parser.h"
#include "exception.h"
#define YY_DECL int yyFlexLexer::yylex(YY_ConfigParser_STYPE *val)
#include "FlexLexer.h"


using std::ifstream;
using std::list;

//--------------------------------------------------------------------
class ConfigReader : public ConfigParser
{
 protected:
  yyFlexLexer scanner_;
  ifstream file_;
  string file_name_;

 public:
  ConfigReader(const string&);
  virtual ~ConfigReader();
  virtual int yylex();
  virtual void yyerror(char *);
  const string& getFileName() const;
  const char* getStringParameter(const char*, const char*) const;
  int getIntParameter(const char*, const char*) const;
  char* getCharArrayParameter(const char*, const char*);
  list<int>& getIntListParameter(const char*, const char*) const;

};

#endif //__config_reader_h__
