%{
#ifndef FLEXFIX
#define FLEXFIX YY_ConfigParser_STYPE *val
#define FLEXFIX2 val
#endif


#include <string.h>
#include <iostream>
using namespace std;

#include "config_parser.h"

%}

WS            [ \t\n]
COMMENT       #.*
DIGIT	      [0-9]
NUMBER	      {DIGIT}+
LETTER        [A-Za-z]

PARAMETER     (("_"|{LETTER})+("_"|{LETTER}|{DIGIT})*)
STRING        ([^\r\n\"\[\]=]*) 
QUOTED_STRING (\"[^\r\n\"]*\") 


%%

{WS}          {/* skip blanks and tabs */}
^{WS}*{COMMENT}     {/* skip comments */}


\[{PARAMETER}\] {
	yytext[strlen(yytext)-1] = '\0';
	val->string = strdup(++yytext);
//	cout << "Lexer: Section " << yytext << endl;
	return ConfigParser::T_SECTION;
}

{STRING} {
//	cout << "Lexer: String " << yytext << endl;
	if(yytext[0] == '~')
        {
	  val->string = new char[strlen(getenv("HOME")) + strlen(yytext)];
	  strcpy(val->string, getenv("HOME"));
	  strcat(val->string, ++yytext);
        }
        else
        {
          val->string = strdup(yytext);
        }
	return ConfigParser::T_STRING;
}

{QUOTED_STRING} {
	yytext[strlen(yytext) -1] = '\0';
        yytext++;
	if(yytext[0] == '~')
        {
	  val->string = new char[strlen(getenv("HOME")) + strlen(yytext)];
	  strcpy(val->string, getenv("HOME"));
	  strcat(val->string, ++yytext);
        }
        else
        {
          val->string = strdup(yytext);
        }
//	cout << "Lexer: String " << yytext << endl;
	return ConfigParser::T_STRING;
}

.  {
	return (yytext[0]);
}

<<EOF>> { yyterminate();}

%%
int yywrap()
{
        return(1);
}


