// $Id: event_handler.h,v 1.7 2003/02/09 19:28:00 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __event_handler_h__
#define __event_handler_h__

#include "dockapp.h"
#include "mixer.h"

#include <iostream>

//--------------------------------------------------------------------
class EventHandler
{
 protected:
  DockApp* dockapp_;
  Mixer* mixer_;

  int current_channel_;
  int num_channels_;
  int wheel_scroll_;
  int repeat_timer_;

  unsigned dragging_;

  bool button_left_pressed_;
  bool button_right_pressed_;
  bool button_mute_pressed_;
  bool button_rec_pressed_;

  void doLeftButton();
  void doRightButton();
  void doMuteButton();
  void doRecButton();
  void doVolumeBar(unsigned, unsigned, int);
  
  void handlePressEvent(int x, int y, int button_number);
  void handleReleaseEvent();
  void handleMotionEvent(int x, int y);
  void handlePressedButton();

  // For repeating next and prev buttons
  static const char RPTINTERVAL  = 7;
  static const char COUNTER_TIME = 7;



 public:
  EventHandler(DockApp*, Mixer*, unsigned);
  virtual ~EventHandler();
  void loop();
};

#endif //__event_handler_h__
