// $Id: exception.cc,v 1.12 2003/03/11 19:40:42 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#include "exception.h"


//--------------------------------------------------------------------
Exception::Exception()
  : error_message_("Unknown error")
{
}

//--------------------------------------------------------------------
Exception::Exception(const string& device)
  : error_message_("wmmixer error:  " + device)
{
}

//--------------------------------------------------------------------
Exception::~Exception()
{
}

//--------------------------------------------------------------------
const string& Exception::getErrorMessage() const
{
  return error_message_;
}

//--------------------------------------------------------------------
MixerDeviceException::MixerDeviceException(const string& device)
  : Exception("Unable to open mixer device: "+device)
{
}

//--------------------------------------------------------------------
MixerDeviceException::~MixerDeviceException()
{
}

//--------------------------------------------------------------------
InvalidChannelException::InvalidChannelException(unsigned channel_num)
  : Exception("Invalid channel: "+channel_num)
{
}

//--------------------------------------------------------------------
InvalidChannelException::InvalidChannelException(const string& error)
  : Exception("Invalid channel: "+error)
{
}

//--------------------------------------------------------------------
InvalidChannelException::~InvalidChannelException()
{
}

//--------------------------------------------------------------------
InvalidConfigFileException::InvalidConfigFileException(const string& error)
  : Exception("Error in config file: "+error)
{

}

//--------------------------------------------------------------------
InvalidThemeException::InvalidThemeException(const string& device)
  : Exception("Invalid Theme: "+device)
{
}

//--------------------------------------------------------------------
FileNotFoundException::FileNotFoundException(const string& device)
  : Exception("File not found: "+device)
{
}
