// $Id: font_map.cc,v 1.5 2002/12/14 11:19:11 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#include "font_map.h"

//--------------------------------------------------------------------
FontMap::FontMap(const char* file_name, unsigned width, unsigned height,
		 XHandler* x_handler) 
  : width_(width), height_(height)
{
  unsigned xpm_width = 0, xpm_height = 0;

  //  width_  = width;
  //  height_ = height;
  font_map_ = x_handler->readPixmapFile((char*)file_name, &xpm_width, &xpm_height);
  
  if(xpm_width < width_ * 36)
    throw InvalidThemeException("Font is invalid");
}

//--------------------------------------------------------------------
FontMap::~FontMap()
{
  delete font_map_;
}

//--------------------------------------------------------------------
Pixmap* FontMap::getPixmap() const
{
  return font_map_;
}

//--------------------------------------------------------------------
int FontMap::getX(char letter) const
{
  if(letter >= 'A' && letter <= 'Z')
    return (letter - 'A') * width_;
  else if(letter >='0' && letter <= '9')
    return (letter - '0' + 26) * width_;
  else if(letter >='a' && letter <= 'z')
    return (letter - 'a') * width_;
  else
    return -1;
}

//--------------------------------------------------------------------
unsigned FontMap::getWidth() const
{
  return width_;
}

