// $Id: graphics.h,v 1.6 2003/01/06 17:51:30 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __graphics_h__
#define __graphics_h__

#include "x_handler.h"

#include "font_map.h"
#include "image.h"
#include "color.h"

#include <string>

static const unsigned BUTTON_DEFAULT = 0;
static const unsigned BUTTON_PRESSED = 1;

class Graphics 
{
 protected:
  XHandler *x_handler_;

 public:
  Graphics(int, char**, const string&, const string&, char);
  virtual ~Graphics();

  void drawImage(Image *, unsigned, unsigned, unsigned, unsigned);
  void drawImageOffset(Image *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned);
  void drawText(const char *, FontMap*, unsigned, unsigned, unsigned, unsigned);
  void drawButton(Image*, unsigned, unsigned, unsigned, unsigned, bool state);
  void drawRectangle(Color *, unsigned, unsigned, unsigned, unsigned);

  XHandler* getXHandler();
  Display* getDisplay();
  Window getWindow();

  void redraw();
};

#endif //__graphics_h__
